datablock AudioProfile(BooSound1)
{
   filename    = "./MouthBoo1.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(BooSound2)
{
   filename    = "./MouthBoo2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(BooSound3)
{
   filename    = "./MouthBoo3.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(BooSound4)
{
   filename    = "./MouthBoo4.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ItemData(SpectatorbooItem : HammerItem) {
	shapeFile = "./boo.dts";
	uiName = "Boo";

	doColorShift = false;

	botDatablock = SpectatorItemsArmor;

	iconName = "";
	image = SpectatorbooImage;
};

datablock ShapeBaseImageData(SpectatorBooImage) {
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = SpectatorBooItem;

	botDatablock = SpectatorItemsArmor;

	armReady = true;

	doColorShift = false;

	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateTimeoutValue[0]				= 0.5;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= true;

	stateName[2]						= "Fire";
	stateTransitionOnTriggerUp[2]		= "Ready";
	stateTimeoutValue[2]				= 1.1;
	stateWaitForTimeout[2]				= true;
	stateAllowImageChange[2]			= true;
	stateScript[2]						= "onFire";
};


function SpectatorBooImage::onMount(%this, %obj, %slot) {
	equipSpectatorHands(%obj, %this.botDatablock);
	%obj.spectatorItemBot.playThread(0, shout);
}

function SpectatorBooImage::onUnmount(%this, %obj, %slot) {
	%obj.spectatorItemBot.delete();
	%obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
}

function SpectatorBooImage::onFire(%this, %obj, %slot) {
	if (isObject(%obj.spectatorItemBot)) {
		%obj.spectatorItemBot.playThread(0, shout);
	}
	serverPlay3D("BooSound" @ getRandom(1, 4), %obj.getHackPosition());
}

function SpectatorBooImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.spectatorItemBot)) {
		%obj.spectatorItemBot.playThread(0, shout);
	}
}