datablock AudioProfile(ClapSound1)
{
   filename    = "./HandClap1.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(ClapSound2)
{
   filename    = "./HandClap2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(ClapSound3)
{
   filename    = "./HandClap3.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ItemData(SpectatorClapItem : HammerItem) {
	shapeFile = "./clap.dts";
	uiName = "Clap";

	doColorShift = false;

	botDatablock = SpectatorItemsArmor;

	iconName = "";
	image = SpectatorClapImage;
};

datablock ShapeBaseImageData(SpectatorClapImage) {
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = SpectatorClapItem;

	botDatablock = SpectatorItemsArmor;

	armReady = true;

	doColorShift = false;

	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateTimeoutValue[0]				= 0.5;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= true;

	stateName[2]						= "Fire";
	stateTransitionOnTriggerUp[2]		= "Ready";
	stateAllowImageChange[2]			= true;
	stateScript[2]						= "onFire";
};


function SpectatorClapImage::onMount(%this, %obj, %slot) {
	equipSpectatorHands(%obj, %this.botDatablock);
	%obj.spectatorItemBot.playThread(0, stopClap);
}

function SpectatorClapImage::onUnmount(%this, %obj, %slot) {
	%obj.spectatorItemBot.delete();
	%obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
	cancel(%obj.clapLoop);
}

function SpectatorClapImage::onFire(%this, %obj, %slot) {
	if (isObject(%obj.spectatorItemBot)) {
		%clapSpeed = getRandom(1, 3);
		switch(%clapSpeed) {
			case 1: %obj.clapSpeed = 208; %anim = "clapFast";
			case 2: %obj.clapSpeed = 250; %anim = "clap";
			case 3: %obj.clapSpeed = 292; %anim = "clapSlow";
		}
		%obj.spectatorItemBot.playThread(0, %anim);
	}
	cancel(%obj.clapLoop);
	%obj.clapLoop = schedule(83, %obj, clapLoop, %obj);
}

function SpectatorClapImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.spectatorItemBot)) {
		%obj.spectatorItemBot.playThread(0, stopClap);
	}
	cancel(%obj.clapLoop);
}

function clapLoop(%pl) {
	cancel(%pl.clapLoop);
	serverPlay3D("ClapSound" @ getRandom(1, 3), %pl.getHackPosition());
	%pl.clapLoop = schedule(%pl.clapSpeed, %pl, clapLoop, %pl);
}