datablock ItemData(SpectatorDabItem : HammerItem) {
	shapeFile = "./dab.dts";
	uiName = "Dab";

	doColorShift = false;

	botDatablock = SpectatorItemsArmor;

	iconName = "";
	image = SpectatorDabImage;
};

datablock ShapeBaseImageData(SpectatorDabImage) {
	shapeFile = "base/data/shapes/empty.dts";
	emap = true;

	// Specify mount point & offset for 3rd person, and eye offset
	// for first person rendering.
	mountPoint = 0;
	eyeOffset = 0; //"0.7 1.2 -0.5";

	className = "WeaponImage";
	item = SpectatorDabItem;

	botDatablock = SpectatorItemsArmor;

	armReady = true;

	doColorShift = false;

	stateName[0]						= "Activate";
	stateScript[0]						= "onActivate";
	stateTimeoutValue[0]				= 0.5;
	stateTransitionOnTimeout[0]			= "Ready";

	stateName[1]						= "Ready";
	stateTransitionOnTriggerDown[1]		= "Fire";
	stateScript[1]						= "onReady";
	stateAllowImageChange[1]			= true;

	stateName[2]						= "Fire";
	stateTransitionOnTriggerUp[2]		= "Ready";
	stateTimeoutValue[2]				= 0.34;
	stateWaitForTimeout[2]				= true;
	stateAllowImageChange[2]			= true;
	stateScript[2]						= "onFire";
};


function SpectatorDabImage::onMount(%this, %obj, %slot) {
	equipSpectatorHands(%obj, %this.botDatablock);
	%obj.spectatorItemBot.playThread(0, dab_root);
	%obj.isDabbing = 0;
	%obj.playThread(0, root);
}

function SpectatorDabImage::onUnmount(%this, %obj, %slot) {
	%obj.spectatorItemBot.delete();
	%obj.emptyBot.delete();
	%obj.client.applyBodyParts();
	%obj.client.applyBodyColors();
}

function SpectatorDabImage::onFire(%this, %obj, %slot) {
	if (isObject(%obj.spectatorItemBot)) {
		%obj.spectatorItemBot.playThread(0, dab_start);
		%obj.playThread(0, headside);
	}
	%obj.isDabbing = 1;
}

function SpectatorDabImage::onReady(%this, %obj, %slot) {
	if (isObject(%obj.spectatorItemBot)) {
		if (%obj.isDabbing) {
			%obj.spectatorItemBot.playThread(0, dab_end);
			%obj.playThread(0, root);
		} else {
			%obj.spectatorItemBot.playThread(0, dab_root);
		}
	}
	%obj.isDabbing = 0;
}