exec("./clap.cs");
exec("./boo.cs");
exec("./dab.cs");

datablock PlayerData(SpectatorItemsArmor : PlayerStandardArmor) {
	shapeFile = "./hands.dts";

	uiName = "";

	boundingBox = vectorScale("20 20 20", 4);
	crouchBoundingBox = vectorScale("20 20 20", 4);
	
	keepWhenDead = 1;
};

package SpectatorItemsPackage {
	function Armor::onDisabled(%this, %obj, %state) {
		if (%this.keepWhenDead) {
			return;
		}

		if (isObject(%obj.spectatorItemBot)) {
			%obj.spectatorItemBot.delete();
		}

		if (isObject(%obj.emptyBot)) {
			%obj.emptyBot.delete();
		}
		return parent::onDisabled(%this, %obj, %state);
	}

	function Armor::onRemove(%this, %obj) {
		if (isObject(%obj.spectatorItemBot)) {
			%obj.spectatorItemBot.delete();
		}

		if (isObject(%obj.emptyBot)) {
			%obj.emptyBot.delete();
		}
		return parent::onRemove(%this, %obj);
	}

	function GameConnection::applyBodyParts(%cl) {
		%ret = parent::applyBodyParts(%cl);
		if (isObject(%cl.player.spectatorItemBot)) {
			applySpectatorItemProperties(%cl.player.spectatorItemBot, 1);
		}
		return %ret;
	}

	function GameConnection::applyBodyColors(%cl) {
		%ret = parent::applyBodyColors(%cl);
		if (isObject(%cl.player.spectatorItemBot)) {
			applySpectatorItemProperties(%cl.player.spectatorItemBot, 1);
		}
		return %ret;
	}

	function serverCmdUseTool(%cl, %slot) {
		if (%cl.player.tool[%slot].botDatablock $= "SpectatorItemArmor") {
			if (getSimTime() - %cl.lastUseTime < 100) {
				cancel(%cl.equipItemSchedule);
				%cl.equipItemSchedule = schedule(150, %cl, serverCmdUseTool, %cl, %slot);
				return;
			}
			%cl.lastUseTime = getSimTime();
		}

		parent::serverCmdUseTool(%cl, %slot);
	}
};
activatePackage(SpectatorItemsPackage);


////////////////////


function equipSpectatorHands(%pl, %botDatablock) {
	if (!isObject(%pl.spectatorItemBot)) {
		%pl.spectatorItemBot = new AIPlayer(SpectatorItemBots) {
			datablock = %botDatablock;
			player = %pl;
		};
		%pl.spectatorItemBot.kill();
	}
	if (!isObject(%pl.emptyBot)) {
		%pl.emptyBot = new AIPlayer(SpectatorItemBots) {
			datablock = %botDatablock;
		};
		%pl.emptyBot.kill();
		%pl.emptyBot.hideNode("ALL");
	}
	%pl.spectatorItemBot.setScale(%pl.getScale());

	%pl.mountObject(%pl.emptyBot, 0);
	%pl.emptyBot.mountObject(%pl.spectatorItemBot, 0);
	%pl.playThread(1, armReadyBoth);

	applySpectatorItemProperties(%pl.spectatorItemBot);
}

function applySpectatorItemProperties(%obj, %bypassApply) {
	%pl = %obj.player;
	%obj.hideNode("ALL");

	if (!isObject(%pl)) {
		return;
	}

	if (!%bypassApply) {
		%pl.client.applyBodyParts();
	}

	if (!isObject(%pl.client)) {
		%obj.unHideNode("rHand");
		%obj.unHideNode("lHand");
		%obj.setNodeColor("ALL", "1 0.878 0.611 1");

		%pl.hideNode("lHand");
		%pl.hideNode("rHand");
		%pl.hideNode("lHook");
		%pl.hideNode("rHook");
		return;
	}

	if (isFunction("GameConnection", "getTeam") && isObject(%pl.client.getTeam())) {
		%team = %pl.client.getTeam();

		if (!%team.uni_rhand) {
			%obj.unHideNode("rHand");
			%pl.hideNode("rHand");
		} else {
			%obj.unHideNode("rHook");
			%pl.hideNode("rHook");
		}
		%obj.setNodeColor("rHand", %team.uni_rHandColor);
		%obj.setNodeColor("rHook", %team.uni_rHandColor);

		if (!%team.uni_lhand) {
			%obj.unHideNode("lHand");
			%pl.hideNode("lHand");
		} else {
			%obj.unHideNode("lHook");
			%pl.hideNode("lHook");
		}
		%obj.setNodeColor("lHand", %team.uni_lHandColor);
		%obj.setNodeColor("lHook", %team.uni_lHandColor);
	} else {
		//hands
		if (!%pl.client.rhand) {
			%obj.unHideNode("rHand");
			%pl.hideNode("rHand");
		} else {
			%obj.unHideNode("rHook");
			%pl.hideNode("rHook");
		}
		%obj.setNodeColor("rHand", %pl.client.rHandColor);
		%obj.setNodeColor("rHook", %pl.client.rHandColor);

		if (!%pl.client.lhand) {
			%obj.unHideNode("lHand");
			%pl.hideNode("lHand");
		} else {
			%obj.unHideNode("lHook");
			%pl.hideNode("lHook");
		}
		%obj.setNodeColor("lHand", %pl.client.lHandColor);
		%obj.setNodeColor("lHook", %pl.client.lHandColor);
	}
}